/* $Header: /home/nygren/courses/6.866/project/src/RCS/imagedisplayer.h,v 1.6 1996/03/02 17:09:59 nygren Exp $ */
/*
 * FILE:    imagedisplayer.h
 * AUTHOR:  Erik Nygren.
 * PURPOSE: Header for image displaying routines.
 *          Written for 6.866 term project, Fall 1995.
 */

#ifndef INC_IMAGEDISPLAYER_H
#define INC_IMAGEDISPLAYER_H

#include <X11/Xlib.h>            /* Xlib include files */
#include "image.h"
#include "opflow.h"

typedef struct _ImageDisplayer {
  uchar    *data;   /* Buffer for displayed image */
  Pixmap    pm;      
  int       xres, yres;
  Window    win;
  GC        gc, pmgc;
  XImage   *ximage;
} ImageDisplayer;

extern void
imagedisplayer_putimage(ImageDisplayer *id, Image *im);

extern ImageDisplayer *
imagedisplayer_create(int xres, int yres, char *window_name);

extern void
imagedisplayer_putiplane_withflow(ImageDisplayer *id, IPlane *ip, OpFlow *of);

extern int
imagedisplayer_init(void);

extern void
imagedisplayer_refresh(ImageDisplayer *id);

extern void
imagedisplayer_get_buttonpress(ImageDisplayer *id, 
			       int *xpos, int *ypos);

extern void
imagedisplayer_destroy(ImageDisplayer *id);

#endif /* INC_IMAGEDISPLAYER_H */
