/* $Header: /home/nygren/courses/6.866/project/src/RCS/linalg.h,v 1.1 1996/02/19 21:04:49 nygren Exp $ */
/*
 * FILE:    linalg.h
 * AUTHOR:  Erik Nygren.
 * PURPOSE: Linear algebra routines.
 *          Written for 6.866 term project, Fall 1995.
 */

#ifndef INC_LINALG_H
#define INC_LINALG_H

typedef struct _Matrix {
  double *el;			/* Elements in row major form */
  int rows, cols;		/* Number of rows and columns */
} Matrix;

/* Indexes a matrix (origin at 0,0)
 *   mat = matrix to index
 *   n = column pos
 *   m = row pos
 * Warning: no bounds checking is done!
 */
#define MIDX(mat, n, m) (((mat)->el)[(m)+(n)*((mat)->cols)])

extern Matrix *
matrix_create(int nrows, int ncols);

extern void
matrix_destroy(Matrix *mat);

extern Matrix *
matrix_create_fromarray(int nrows, int ncols, double *data);

extern void
matrix_print(const Matrix *A, const char *name);

extern int
matrix_slu(Matrix *L, Matrix *U, const Matrix *A);

extern int
matrix_slv(Matrix *x, const Matrix *A, const Matrix *b);

extern int
matrix_lsq(Matrix *x, const Matrix *A, const Matrix *b);

extern void
matrix_copy(Matrix *DEST, const Matrix *SRC);

extern Matrix *
matrix_duplicate(const Matrix *A);

extern void
matrix_zero(Matrix *A);

extern int
matrix_mult(Matrix *C, const Matrix *A, const Matrix *B);

extern int
matrix_transpose(Matrix *B, const Matrix *A);


#endif /* INC_LINALG_H */
