/* $Header: /home/nygren/courses/6.866/project/src/RCS/opflow.h,v 1.2 1996/02/17 19:36:41 nygren Exp $ */
/*
 * FILE:    opflow.h
 * AUTHOR:  Erik Nygren.
 * PURPOSE: Header for optical flow
 *          Written for 6.866 term project, Fall 1995.
 */

#ifndef INC_OPFLOW_H
#define INC_OPFLOW_H

typedef struct _DerivField 
{
  int    xres, yres;
  double *data;
} DerivField;

typedef struct _OpFlow
{
  int    xres, yres;
  double *u, *v;     /* u and v motion fields */
} OpFlow;

extern DerivField *
derivfield_make(int x, int y);

extern DerivField *
derivfield_make_Ex(IPlane *ip0, IPlane *ip1);

extern DerivField *
derivfield_make_Ey(IPlane *ip0, IPlane *ip1);

extern DerivField *
derivfield_make_Et(IPlane *ip0, IPlane *ip1);

extern double
derivfield_getval(DerivField *df, int x, int y);

extern OpFlow *
opflow_make(int x, int y);

extern void 
opflow_destroy(OpFlow *of);

extern OpFlow *
opflow_doiter(OpFlow *of0, DerivField *ExField, DerivField *EyField,
	      DerivField *EtField, double Lambda);


#endif /* INC_OPFLOW_H */

