/* $Header: /home/nygren/courses/6.866/project/src/RCS/testbuttons.c,v 1.1 1996/02/17 19:36:41 nygren Exp $ */
/*
 * FILE:    testimage.c
 * AUTHOR:  Erik Nygren.
 * PURPOSE: Reads an image in, plays with it, then writes it out.
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include "image.h"
#include "imagedisplayer.h"


/* prototypes */
void getkey(void);

void
getkey(void)
{
  char buf[20];
  printf("press a key...");
  fgets(buf, 19, stdin);
}

void
main(int argc, char *argv[])
{
  Image *im0, *im1;
  ImageDisplayer *id0, *id1;
  int fd;
  int ptctr=0;

  if (argc<3)
    {
      fprintf(stderr, "Invalid args\n");
      exit(-1);
    }
  
  fd = open(argv[1], O_RDONLY);
  im0 = image_loadpnm(fd, argv[1]);
  close(fd);

  fd = open(argv[2], O_RDONLY);
  im1 = image_loadpnm(fd, argv[2]);
  close(fd);
  
  if (!im0)
    { fprintf(stderr, "Error loading image %s\n", argv[1]);
      exit(-1); }

  if (!im1)
    { fprintf(stderr, "Error loading image %s\n", argv[2]);
      exit(-1); }

  if ((im0->xres != im1->xres)
      || (im0->yres != im1->yres))
    { fprintf(stderr, "Image resolutions do not match!\n");
      exit(-1); }

  imagedisplayer_init();
  id0 = imagedisplayer_create(im0->xres, im0->yres, argv[1]);
  id1 = imagedisplayer_create(im1->xres, im1->yres, argv[1]);
  if (!id0 || !id1)
    {
      fprintf(stderr, "Error opening window\n");
      exit(-1);
    }
  
  imagedisplayer_putimage(id0, im0);
  imagedisplayer_putimage(id1, im1);
 
  while (1)
    {
      int xpos, ypos;

      printf("\n\n\n%d: Select a point in Window 0: ", ptctr);
      imagedisplayer_get_buttonpress(id0, &xpos, &ypos);
      printf("(%d %d)\n", xpos-(im0->xres)/2, ypos-(im0->yres)/2);
      printf("%d: Select a point in Window 1: ", ptctr);
      imagedisplayer_get_buttonpress(id1, &xpos, &ypos);
      printf("(%d %d)\n", xpos-(im1->yres)/2, ypos-(im1->yres)/2);
      ptctr++;
    }
}
