/* $Header: /home/nygren/courses/6.866/project/src/RCS/testimagemotif.c,v 1.1 1996/02/28 18:38:30 nygren Exp $ */
/*
 * FILE:    testimage.c
 * AUTHOR:  Erik Nygren.
 * PURPOSE: Reads an image in, plays with it, then writes it out.
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include "image.h"
#include "imagedisplayer.h"


void
getkey(void)
{
  char buf[20];
  printf("press a key...");
  fgets(buf, 19, stdin);
}

void
main(int argc, char *argv[])
{
  Image *im;
  ImageDisplayer *id;
  int fd;
  int argctr;

  if (argc<2)
    {
      fprintf(stderr, "Invalid args\n");
      exit(-1);
    }
  
  if (0==strcmp(argv[1],"-"))
    fd = 0;
  else
    fd = open(argv[1], O_RDONLY);
  im = image_loadpnm(fd, argv[1]);
  close(fd);

  if (!im)
    {
      fprintf(stderr, "Error loading image\n");
      exit(-1);
    }

  imagedisplayer_init(argc, argv);
  id = imagedisplayer_create(im->xres, im->yres, argv[1]);
  if (!id)
    {
      fprintf(stderr, "Error opening window\n");
      exit(-1);
    }

  imagedisplayer_putimage(id, im); getkey();

  fprintf(stderr, "Done.\n");
}
