/* $Header: /home/nygren/courses/6.866/project/src/RCS/testlinalg.c,v 1.1 1996/02/19 21:04:49 nygren Exp $ */
/*
 * FILE:    linalg.c
 * AUTHOR:  Erik Nygren.
 * PURPOSE: Linear algebra routines.
 *          Written for 6.866 term project, Fall 1995.
 */

#include <stdio.h>
#include <math.h>
#include "linalg.h"

void
test_slu(void)
{
  Matrix *A, *L, *U;
  double Adata[] = { 4.0, 5.0, 6.0, 8.0, 
		       6.0, 7.0, 2.0, 1.0,
		       5.0, 1.0, 4.0, 8.0,
		       4.0, 2.0, 7.0, 9.0};
  
  printf("\n-------- TEST SLU -------\n");

  A = matrix_create_fromarray(4,4,Adata);
      
  L = matrix_create(4,4);
  U = matrix_create(4,4);

  matrix_print(A,"A");
  matrix_slu(L,U, A);
  matrix_print(A,"A");
  matrix_print(L,"L");
  matrix_print(U,"U");
}


/* 
 *  >> slv([5 6 2 6; 6 2 3 1; 5 9 2 4; 1 4 5 9],[1 2 3 4]')
 *  
 *  ans =
 *  
 *  -0.3422
 *  0.4218
 *  1.1923
 *  -0.3674
 */   
 
void
test_slv(void)
{
  Matrix *A, *b, *x;
  double Adata[] = { 5.0, 6.0, 2.0, 6.0,
		       6.0, 2.0, 3.0, 1.0,
		       5.0, 9.0, 2.0, 4.0,
		       1.0, 4.0, 5.0, 9.0 };
  double bdata[] = { 1.0, 2.0, 3.0, 4.0 };
  
  printf("\n-------- TEST SLV -------\n");

  A = matrix_create_fromarray(4,4,Adata);
  b = matrix_create_fromarray(4,1,bdata);
  x = matrix_create(4,1);

  matrix_print(A,"A");
  matrix_print(b,"b");
  matrix_slv(x, A,b);
  matrix_print(A,"A");
  matrix_print(b,"b");
  matrix_print(x,"x");
}

void
test_lsq(void)
{
  Matrix *A, *b, *x;
  double Adata[] = { 5.0, 6.0, 2.0, 6.0,
		       6.0, 2.0, 3.0, 1.0,
		       5.0, 9.0, 2.0, 4.0,
		       4.0, 12.0, 3.0, 5.0,
		       1.5, 4.7, 5.9, 8.3,
		       1.0, 4.0, 5.0, 9.0 };
  double bdata[] = { 1.0, 2.0, 3.0, 4.0, 5.0, 6.0 };
  
  printf("\n-------- TEST LSQ -------\n");

  A = matrix_create_fromarray(6,4,Adata);
  b = matrix_create_fromarray(6,1,bdata);
  x = matrix_create(4,1);

  matrix_print(A,"A");
  matrix_print(b,"b");
  matrix_lsq(x, A,b);
  matrix_print(A,"A");
  matrix_print(b,"b");
  matrix_print(x,"x");
}


void
test_mult(void)
{
  Matrix *A, *B, *C;
  double Adata[] = { 5.0, 6.0, 2.0,
		       6.0, 2.0, 3.0,
		       5.0, 9.0, 2.0,
		       1.0, 4.0, 5.0, };
  double Bdata[] = { 4.0, 5.0, 6.0, 8.0, 
		       6.0, 7.0, 2.0, 1.0,
		       4.0, 2.0, 7.0, 9.0};

  
  printf("\n-------- TEST MATRIX_MULT -------\n");

  A = matrix_create_fromarray(4,3,Adata);
  B = matrix_create_fromarray(3,4,Bdata);
  C = matrix_create(4,4);

  matrix_print(A,"A");
  matrix_print(B,"B");
  matrix_mult(C, A,B);
  matrix_print(A,"A");
  matrix_print(B,"B");
  matrix_print(C,"C");
}

void
test_transpose(void)
{
  Matrix *A, *B;
  double Adata[] = { 5.0, 6.0, 2.0,
		       6.0, 2.0, 3.0,
		       5.0, 9.0, 2.0,
		       1.0, 4.0, 5.0, };
  
  printf("\n-------- TEST MATRIX_TRANSPOSE -------\n");

  A = matrix_create_fromarray(4,3,Adata);
  B = matrix_create(3,4);

  matrix_print(A,"A");
  matrix_transpose(B, A);
  matrix_print(A,"A");
  matrix_print(B,"B");
}



void
main(void)
{
  test_mult();
  test_slu();
  test_slv();
  test_transpose();
  test_lsq();
}

