/* $Header: /home/nygren/courses/6.866/project/src/RCS/testproj.c,v 1.1 1996/02/19 21:04:49 nygren Exp nygren $ */
/*
 * FILE:    testproj.c
 * AUTHOR:  Erik Nygren.
 * PURPOSE: Reads an image in, projects it, then displays it/
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include "image.h"
#include "imagedisplayer.h"
#include "projxform.h"


/* prototypes */
void getkey(void);

void
getkey(void)
{
  char buf[20];
  printf("press a key...");
  fgets(buf, 19, stdin);
}

void
main(int argc, char *argv[])
{
  Image *imA, *imB, *imMerge;
  ImageDisplayer *idA, *idB, *idMerge;
  ProjXForm *pxfA, *pxfB;
  int fd;
  int ptctr=0;

  if (argc<3)
    {
      fprintf(stderr, "Invalid args\n");
      exit(-1);
    }
  
  fd = open(argv[1], O_RDONLY);
  imA = image_loadpnm(fd, argv[1]);
  close(fd);
  fd = open(argv[2], O_RDONLY);
  imB = image_loadpnm(fd, argv[2]);
  close(fd);

  imMerge = image_create(imA->xres*2, imA->yres*2, imA->np); 

  if (!imA)
    { fprintf(stderr, "Error loading image %s\n", argv[1]);
      exit(-1); }
  if (!imB)
    { fprintf(stderr, "Error loading image %s\n", argv[2]);
      exit(-1); }

  pxfA = projxform_create_identity();
  pxfB = projxform_create(1.0127,  0.0119, -121.3724,
			  -0.0059, 1.0546, -4.5897,
			  0.0007, 0.0, 0.0007, 0.0);

  fprintf(stderr, "Loaded %s.  Doing transform ... ", argv[1]);
  projxform_xform_image(pxfA, imMerge, imA);
  fprintf(stderr, "Done.\n");

  fprintf(stderr, "Loaded %s.  Doing transform ... ", argv[2]);
  projxform_xform_image(pxfB, imMerge, imB);
  fprintf(stderr, "Done.\n");

  imagedisplayer_init();
  idA = imagedisplayer_create(imA->xres, imA->yres, argv[1]);
  idB = imagedisplayer_create(imB->xres, imB->yres, argv[2]);
  idMerge = imagedisplayer_create(imMerge->xres, imMerge->yres, 
				  "Merged Projection");
  if (!idA || !idB || !idMerge)
    {
      fprintf(stderr, "Error opening window\n");
      exit(-1);
    }
  
  imagedisplayer_putimage(idA, imA);
  imagedisplayer_putimage(idB, imB);
  imagedisplayer_putimage(idMerge, imMerge);
 
  while (1)
    {
      int xpos, ypos;

      printf("\n\n\n%d: Select a point in Window 0: ", ptctr);
      imagedisplayer_get_buttonpress(idA, &xpos, &ypos);
      printf("(%d %d)\n", xpos-(imA->xres)/2, ypos-(imA->yres)/2);
      printf("%d: Select a point in Window 1: ", ptctr);
      imagedisplayer_get_buttonpress(idB, &xpos, &ypos);
      printf("(%d %d)\n", xpos-(imB->yres)/2, ypos-(imB->yres)/2);
      ptctr++;
    }
}
