/* $Header: /home/nygren/courses/6.866/project/src/RCS/util.c,v 1.1 1996/02/19 21:04:49 nygren Exp $ */
/*
 * FILE:    util.c
 * AUTHOR:  Erik Nygren.
 * PURPOSE: Utility routines.
 *          Written for 6.866 term project, Fall 1995.
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include "util.h"

/******************** UTILITIES *****************/

/* Does a malloc and prints an error and exits if the malloc fails.
 * loc is the location from which xmalloc is being called. */
void *
xmalloc(char* loc, size_t size)
{
  void *retval;
  if (NULL == (retval = malloc(size)))
    {
      fprintf(stderr, "xalloc: malloc failed to allocate %d bytes in %s\n",
	      size, loc);
      exit(-1);
    }
  return(retval);
}

/* Does a calloc and prints an error and exits if the calloc fails.
 * loc is the location from which xcalloc is being called. */
void *
xcalloc(char* loc, size_t nmemb, size_t size)
{
  void *retval;
  if (NULL == (retval = calloc(nmemb, size)))
    {
      fprintf(stderr, "xmalloc: calloc failed to allocate %dx%d bytes in %s\n",
	      nmemb, size, loc);
      exit(-1);
    }
  return(retval);
}

void
xfree(void *tofree)
{
  free(tofree);
}

/* duplicates a string */
char *
string_dup(char *s)
{
  char *newstr;

  newstr = (char*)xcalloc("string_dup", strlen(s)+1, sizeof(char));
  strcpy(newstr, s);
  return(newstr);
}
